import { type AuthData } from 'firebase-functions/lib/common/providers/https';
import { type DatabaseType, Guid, type IFirebaseFunction, type IFunctionType, type IParameterContainer, type IDatabaseReference, type ILogger } from '../src';
import { type DatabaseScheme } from './DatabaseScheme';
export declare class AddPersonFunction implements IFirebaseFunction<AddPersonFunctionType> {
    private readonly auth;
    private readonly databaseReference;
    private readonly logger;
    readonly parameters: IFunctionType.Parameters<AddPersonFunctionType> & {
        databaseType: DatabaseType;
    };
    constructor(parameterContainer: IParameterContainer, auth: AuthData | null, databaseReference: IDatabaseReference<DatabaseScheme>, logger: ILogger);
    execute(): Promise<IFunctionType.ReturnType<AddPersonFunctionType>>;
}
export type AddPersonFunctionType = IFunctionType<{
    id: Guid;
    name: string;
    age: number;
}, void, {
    id: string;
    name: string;
    age: number;
}>;
