import { type AuthData } from 'firebase-functions/lib/common/providers/https';
import { type DatabaseType, type IFirebaseFunction, type IFunctionType, type IParameterContainer, type IDatabaseReference, type ILogger } from '../src';
import { type DatabaseScheme } from './DatabaseScheme';
export declare class GetAnimalsFunction implements IFirebaseFunction<GetAnimalsFunctionType> {
    private readonly auth;
    private readonly databaseReference;
    private readonly logger;
    readonly parameters: IFunctionType.Parameters<GetAnimalsFunctionType> & {
        databaseType: DatabaseType;
    };
    constructor(parameterContainer: IParameterContainer, auth: AuthData | null, databaseReference: IDatabaseReference<DatabaseScheme>, logger: ILogger);
    execute(): Promise<IFunctionType.ReturnType<GetAnimalsFunctionType>>;
}
export type GetAnimalsFunctionType = IFunctionType<Record<string, never>, Array<{
    id: string;
    name: string;
}>>;
