"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Guid = void 0;
const uuid_1 = require("uuid");
const HttpsError_1 = require("./HttpsError");
class Guid {
    guidString;
    constructor(guidString) {
        this.guidString = guidString;
    }
}
exports.Guid = Guid;
(function (Guid) {
    function fromString(value, logger) {
        logger.log('guid.fromString', { value: value });
        const regex = /^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-4[0-9a-fA-F]{3}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$/;
        if (!regex.test(value))
            throw (0, HttpsError_1.HttpsError)('internal', `Couldn't parse Guid, guid string isn't a valid Guid: ${value}`, logger);
        return new Guid(value.toUpperCase());
    }
    Guid.fromString = fromString;
    function newGuid() {
        return new Guid((0, uuid_1.v4)().toUpperCase());
    }
    Guid.newGuid = newGuid;
})(Guid = exports.Guid || (exports.Guid = {}));
